---
title: vertical-align
slug: Web/CSS/vertical-align
tags:
  - CSS
  - CSS Property
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>vertical-align</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets vertical alignment of an inline, inline-block or table-cell box.</p>

<div>{{EmbedInteractiveExample("pages/css/vertical-align.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The vertical-align property can be used in two contexts:</p>

<ul>
 <li>To vertically align an inline element's box inside its containing line box. For example, it could be used to vertically position an {{HTMLElement("img")}} in a line of text:</li>
</ul>

<div id="vertical-align-inline">
<pre class="hidden brush: html notranslate">&lt;p&gt;
top:&lt;img style="vertical-align:top" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
middle:&lt;img style="vertical-align:middle" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
bottom:&lt;img style="vertical-align:bottom" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
super:&lt;img style="vertical-align:super" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
sub:&lt;img style="vertical-align:sub" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
&lt;/p&gt;
&lt;p&gt;
text-top:&lt;img style="vertical-align:text-top" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
text-bottom:&lt;img  style="vertical-align:text-bottom" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
0.2em:&lt;img style="vertical-align:0.2em" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
-1em:&lt;img  style="vertical-align:-1em" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
20%:&lt;img style="vertical-align:20%" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
-100%:&lt;img  style="vertical-align:-100%" src="https://mdn.mozillademos.org/files/15189/star.png"/&gt;
&lt;/p&gt;

</pre>

<pre class="hidden brush: css notranslate">#* {
  box-sizing: border-box;
}

img {
  margin-right: 0.5em;
}

p {
  height: 3em;
  padding: 0 .5em;
  font-family: monospace;
  text-decoration: underline overline;
  margin-left: auto;
  margin-right: auto;
  width: 80%;
}
</pre>
</div>

<p>{{EmbedLiveSample("vertical-align-inline", 1200, 120, "", "", "example-outcome-frame")}}</p>

<ul>
 <li>To vertically align the content of a cell in a table:</li>
</ul>

<div id="vertical-align-table">
<pre class="hidden brush: html notranslate">&lt;table&gt;
  &lt;tr&gt;
    &lt;td style="vertical-align: baseline"&gt;baseline&lt;/td&gt;
    &lt;td style="vertical-align: top"&gt;top&lt;/td&gt;
    &lt;td style="vertical-align: middle"&gt;middle&lt;/td&gt;
    &lt;td style="vertical-align: bottom"&gt;bottom&lt;/td&gt;
    &lt;td&gt;
      &lt;p&gt;There is a theory which states that if ever anyone discovers exactly what the Universe is for and why it is here, it will instantly disappear and be replaced by something even more bizarre and inexplicable.&lt;/p&gt;
&lt;p&gt;There is another theory which states that this has already happened.&lt;/p&gt;
    &lt;/td&gt;
  &lt;/tr&gt;
&lt;/table&gt;

</pre>

<pre class="hidden brush: css notranslate">table {
  margin-left: auto;
  margin-right: auto;
  width: 80%;
}

table, th, td {
  border: 1px solid black;
}

td {
  padding: 0.5em;
  font-family: monospace;
}
</pre>
</div>

<p>{{EmbedLiveSample("vertical-align-table", 1200, 210, "", "", "example-outcome-frame")}}</p>

<p>Note that <code>vertical-align</code> only applies to inline, inline-block and table-cell elements: you can't use it to vertically align <a href="/en-US/docs/Web/HTML/Block-level_elements">block-level elements</a>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* Keyword values */
vertical-align: baseline;
vertical-align: sub;
vertical-align: super;
vertical-align: text-top;
vertical-align: text-bottom;
vertical-align: middle;
vertical-align: top;
vertical-align: bottom;

/* &lt;length&gt; values */
vertical-align: 10em;
vertical-align: 4px;

/* &lt;percentage&gt; values */
vertical-align: 20%;

/* Global values */
vertical-align: inherit;
vertical-align: initial;
vertical-align: unset;
</pre>

<p>The <code>vertical-align</code> property is specified as one of the values listed below.</p>

<h3 id="Values_for_inline_elements">Values for inline elements</h3>

<h4 id="Parent-relative_values">Parent-relative values</h4>

<p>These values vertically align the element relative to its parent element:</p>

<dl>
 <dt><code>baseline</code></dt>
 <dd>Aligns the baseline of the element with the baseline of its parent. The baseline of some <a href="/en-US/docs/Web/CSS/Replaced_element">replaced elements</a>, like {{HTMLElement("textarea")}}, is not specified by the HTML specification, meaning that their behavior with this keyword may vary between browsers.</dd>
 <dt><code>sub</code></dt>
 <dd>Aligns the baseline of the element with the subscript-baseline of its parent.</dd>
 <dt><code>super</code></dt>
 <dd>Aligns the baseline of the element with the superscript-baseline of its parent.</dd>
 <dt><code>text-top</code></dt>
 <dd>Aligns the top of the element with the top of the parent element's font.</dd>
 <dt><code>text-bottom</code></dt>
 <dd>Aligns the bottom of the element with the bottom of the parent element's font.</dd>
 <dt><code>middle</code></dt>
 <dd>Aligns the middle of the element with the baseline plus half the x-height of the parent.</dd>
 <dt>{{cssxref("&lt;length&gt;")}}</dt>
 <dd>Aligns the baseline of the element to the given length above the baseline of its parent. A negative value is allowed.</dd>
 <dt>{{cssxref("&lt;percentage&gt;")}}</dt>
 <dd>Aligns the baseline of the element to the given percentage above the baseline of its parent, with the value being a percentage of the {{Cssxref("line-height")}} property. A negative value is allowed.</dd>
</dl>

<h4 id="Line-relative_values">Line-relative values</h4>

<p>The following values vertically align the element relative to the entire line:</p>

<dl>
 <dt><code>top</code></dt>
 <dd>Aligns the top of the element and its descendants with the top of the entire line.</dd>
 <dt><code>bottom</code></dt>
 <dd>Aligns the bottom of the element and its descendants with the bottom of the entire line.</dd>
</dl>

<p>For elements that do not have a baseline, the bottom margin edge is used instead.</p>

<h3 id="Values_for_table_cells">Values for table cells</h3>

<dl>
 <dt><code>baseline</code> (and <code>sub</code>, <code>super</code>, <code>text-top</code>, <code>text-bottom</code>, <code>&lt;length&gt;</code>, and <code>&lt;percentage&gt;</code>)</dt>
 <dd>Aligns the baseline of the cell with the baseline of all other cells in the row that are baseline-aligned.</dd>
 <dt><code>top</code></dt>
 <dd>Aligns the top padding edge of the cell with the top of the row.</dd>
 <dt><code>middle</code></dt>
 <dd>Centers the padding box of the cell within the row.</dd>
 <dt><code>bottom</code></dt>
 <dd>Aligns the bottom padding edge of the cell with the bottom of the row.</dd>
</dl>

<p>Negative values are allowed.</p>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div&gt;An &lt;img src="https://mdn.mozillademos.org/files/12245/frame_image.svg" alt="link" width="32" height="32" /&gt; image with a default alignment.&lt;/div&gt;
&lt;div&gt;An &lt;img class="top" src="https://mdn.mozillademos.org/files/12245/frame_image.svg" alt="link" width="32" height="32" /&gt; image with a text-top alignment.&lt;/div&gt;
&lt;div&gt;An &lt;img class="bottom" src="https://mdn.mozillademos.org/files/12245/frame_image.svg" alt="link" width="32" height="32" /&gt; image with a text-bottom alignment.&lt;/div&gt;
&lt;div&gt;An &lt;img class="middle" src="https://mdn.mozillademos.org/files/12245/frame_image.svg" alt="link" width="32" height="32" /&gt; image with a middle alignment.&lt;/div&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">img.top { vertical-align: text-top; }
img.bottom { vertical-align: text-bottom; }
img.middle { vertical-align: middle; }
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Basic_example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS2.1', 'visudet.html#propdef-vertical-align', 'vertical-align')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Adds the {{cssxref("&lt;length&gt;")}} value and allows it to be applied to elements with a {{cssxref("display")}} type of <code>table-cell</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '#vertical-align', 'vertical-align')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.vertical-align")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Flexible_Box_Layout/Typical_Use_Cases_of_Flexbox#Center_item">Typical use cases of Flexbox, section "Center item"</a></li>
 <li>{{Cssxref("line-height")}}, {{Cssxref("text-align")}}, {{Cssxref("margin")}}</li>
 <li><a href="http://phrogz.net/css/vertical-align/index.html">Understanding <code>vertical-align</code>, or "How (Not) To Vertically Center Content"</a></li>
 <li><a href="https://christopheraue.net/design/vertical-align">Vertical-Align: All You Need To Know</a></li>
</ul>
